-- copland.e
-- Macintosh-style controls

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style

constant
    g = GRAY,
    w = WHITE,
    o = BRIGHT_WHITE,
    z = WHITE
integer b


object result

-- position of close box
    CLOSE_BOX_COL = 2

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color black
    -- gray if dim

    if dim then
        b = GRAY
    else
        b = BLACK
    end if

end procedure


-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
               integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio button

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    c1 = col*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)+1
    r2 = r1+11


    if check then
        pixel( { z,z,z,g,b,b,b,b,g,z,z,z }, {c1, r1+0} )
        pixel( { z,z,b,b,g,g,g,g,g,b,z,z }, {c1, r1+1} )
        pixel( { z,b,g,g,g,g,g,g,g,g,b,z }, {c1, r1+2} )
        pixel( { w,b,g,g,b,b,b,b,g,g,g,w }, {c1, r1+3} )
        pixel( { b,g,g,b,b,b,b,b,b,g,w,g }, {c1, r1+4} )
        pixel( { b,g,g,b,b,b,b,b,b,w,w,b }, {c1, r1+5} )
        pixel( { b,g,g,b,b,b,b,b,b,w,w,b }, {c1, r1+6} )
        pixel( { b,g,g,b,b,b,b,b,b,w,o,g }, {c1, r1+7} )
        pixel( { w,b,g,g,b,b,b,b,g,o,g,w }, {c1, r1+8} )
        pixel( { z,b,g,g,g,w,w,w,o,o,b,z }, {c1, r1+9} )
        pixel( { z,z,b,g,w,w,w,o,g,b,z,z }, {c1, r1+10} )
        pixel( { z,z,z,w,g,b,b,g,w,z,z,z }, {c1, r1+11} )
    else
        pixel( { z,z,z,w,g,b,b,g,w,z,z,z }, {c1, r1+0} )
        pixel( { z,z,b,g,w,w,w,w,g,b,z,z }, {c1, r1+1} )
        pixel( { z,b,g,g,o,o,o,o,w,g,b,z }, {c1, r1+2} )
        pixel( { w,g,w,o,o,o,o,o,w,w,g,w }, {c1, r1+3} )
        pixel( { g,w,o,o,o,o,o,w,w,w,g,g }, {c1, r1+4} )
        pixel( { b,g,o,o,o,o,w,w,w,w,g,b }, {c1, r1+5} )
        pixel( { b,g,o,o,o,w,w,w,w,w,g,b }, {c1, r1+6} )
        pixel( { g,w,o,o,w,w,w,w,w,w,g,g }, {c1, r1+7} )
        pixel( { w,g,w,w,w,w,w,w,w,g,g,w }, {c1, r1+8} )
        pixel( { z,b,g,w,w,w,w,w,g,g,b,z }, {c1, r1+9} )
        pixel( { z,z,b,g,g,g,g,g,g,b,z,z }, {c1, r1+10} )
        pixel( { z,z,z,w,g,b,b,g,w,z,z,z }, {c1, r1+11} )
    
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
               integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box

    integer c1, r1, c2, r2
    sequence s

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )
    
    -- convert to points
    c1 = col*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)
    r2 = r1+11

    -- border
    polygon( BLACK, 0, {{c1, r1},{c2,r1},{c2,r2},{c1,r2}} )
    
    -- filled box
    polygon( WHITE, 1, {{c1+1, r1+1},
                        {c2-1, r1+1},
                        {c2-1, r2-1},
                        {c1+1, r2-1}} )

    -- reflection
    draw_line( BRIGHT_WHITE, {{c1+1, r2-2},
                              {c1+1, r1+1},
                              {c2-2, r1+1} })
                              
    -- shadow
    draw_line( GRAY, {{c2-1, r1+2},
                      {c2-1, r2-1},
                      {c1+2, r2-1}} )
                      
    -- check mark
    if check then  
        pixel( { b,w,w,w,w,b,w }, {c1+3, r1+2} )
        pixel( { b,b,w,w,b,b,g }, {c1+3, r1+3} )
        pixel( { w,b,b,b,b,g,w }, {c1+3, r1+4} )
        pixel( { w,w,b,b,g,w,w }, {c1+3, r1+5} )
        pixel( { w,b,b,b,b,w,w }, {c1+3, r1+6} )
        pixel( { b,b,g,w,b,b,w }, {c1+3, r1+7} )
        pixel( { b,g,w,w,w,b,g }, {c1+3, r1+8} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title, integer col1, integer row1, 
                integer wide, integer pressed, integer dim, integer hot,
                 integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, color

    -- hide mouse
    mouse_pointer(0)


    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

        
    -- filled button
    polygon( WHITE, 1, {{c1+2, r1}, 
                        {c2-2,r1},
                        {c2,r1+2},
                        {c2,r2-2},
                        {c2-2,r2},
                        {c1+2,r2},
                        {c1,r2-2},
                        {c1,r1+2}} )
                        
    -- border
    polygon( b, 0, {{c1+2, r1}, 
                    {c2-2,r1},
                    {c2,r1+2},
                    {c2,r2-2},
                    {c2-2,r2},
                    {c1+2,r2},
                    {c1,r2-2},
                    {c1,r1+2}} )

    if pressed then
        color = GRAY
    else
        color = BRIGHT_WHITE
    end if

    -- top reflection
    draw_line( color, {{c1+2, r2-3},
                      {c1+2,r1+2},
                      {c2-3,r1+2}} )
    pixel( color, {c1+3,r1+3} )

    if not pressed then
    
        -- right & bottom shadow
        draw_line( GRAY, {{c2-1, r1+3},
                          {c2-1, r2-2},
                          {c2-2, r2-2},
                          {c2-2, r2-1},
                          {c1+3, r2-1}} )

    end if
    
    -- face of button
                                 
    -- title
    center = floor( (wide/2) - (length(title)/2) ) - 1
    graphic_title( title, {b, WHITE}, row1, col1+center, hot, is_focus )    

    -- single border
    draw_line( BLACK, {{c1, r1+1}, {c1, r2-1}} )
    draw_line( BLACK, {{c2, r1+1}, {c2, r2-1}} )
    draw_line( BLACK, {{c1+1,r1}, {c2-1,r1}} ) 
    draw_line( BLACK, {{c1+1,r2}, {c2-1,r2}} )
        
    -- focus?
    if focus then
        color = BLACK
    else
        color = WHITE
    end if

    draw_line( color, {{c1-1, r1}, {c1-1, r2}} )
    draw_line( color, {{c2+1, r1}, {c2+1, r2}} )
    draw_line( color, {{c1,r1-1}, {c2,r1-1}} ) 
    draw_line( color, {{c1,r2+1}, {c2,r2+1}} )
    pixel( color, {c1, r1} )
    pixel( color, {c1, r2} )
    pixel( color, {c2, r1} )
    pixel( color, {c2, r2} )


    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_box( integer row, integer col, integer show )

    integer c, r

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c = col*cWide
    r = row*cTall

    if show = 0 then
        -- erase it
        polygon( WHITE, 1, {{c+1,r},
                            {c+cTall-1,r},
                            {c+cTall-1,r+(cWide*2)},
                            {c+1,r+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    -- BLACK surrounding
    polygon( BLACK, 0, {{c,r},
                        {c,r+(cWide*2)},
                        {c+cTall,r+(cWide*2)},
                        {c+cTall,r}} )
    
    -- top reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+cTall-1,r+1}})
    
    -- left reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+1,r+(cWide*2)-2}})    
    
    -- bottom shadow
    draw_line( GRAY, {{c+2,r+(cWide*2)-2},{c+cTall-2,r+(cWide*2)-2}})    
    draw_line( GRAY, {{c+1,r+(cWide*2)-1},{c+cTall-2,r+(cWide*2)-1}})    
    
    -- right shadow
    draw_line( GRAY, {{c+cTall-2,r+2},{c+cTall-2,r+(cWide*2)-1}})
    draw_line( GRAY, {{c+cTall-1,r+1},{c+cTall-1,r+(cWide*2)-1}})
    
    -- face
    polygon( WHITE, 1, {{c+2,r+2},
                        {c+cTall-3,r+2},
                        {c+cTall-3,r+(cWide*2)-3},
                        {c+2,r+(cWide*2)-3}} )

    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    integer c, r

    -- the box
    graphic_box( row, col, show )

    if show then

        -- hide mouse
        mouse_pointer(0)

        -- convert to points
        c = col*cWide
        r = row*cTall
    
        -- the decoration
    
        for i = 1 to 10 by 2 do
            draw_line( BRIGHT_WHITE, {{c+3, r+i+2},{c+12, r+i+2}} )
            draw_line( GRAY,         {{c+3, r+i+3},{c+12, r+i+3}} )
        end for

        -- show mouse
        mouse_pointer(1)

    end if

end procedure

----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

        -- scroll bar
        polygon( WHITE, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow
        -- box
        graphic_box( row, col-1, 1 )
    
        -- up arrow
        polygon( BLACK, 1, {{c1+7, r1+6},
                            {c1+4, r1+9},
                            {c1+11,r1+9},
                            {c1+8, r1+6}} )

    -- the down arrow
        -- box
        graphic_box( row+deep-1, col-1, 1 )
    
        -- convert to points
        r1 = (row+deep-1)*cTall
    
        -- down arrow
        polygon( BLACK, 1, {{c1+4, r1+6},
                            {c1+11,r1+6},
                            {c1+8, r1+9},
                            {c1+7, r1+9}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- draw a slab

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall) 
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{c1,r1-2},{c2,r1-2},{c2,r2},{c1,r2}})

    -- reflection
    draw_line( BRIGHT_WHITE, {{c1+1, r2-1}, {c1+1, r1-1}, {c2, r1-1}} )

    -- facet shadow
    draw_line( GRAY, {{c2-1, r1-1}, {c2-1, r2-1}, {c1+1, r2-1}} )

    -- shadow
    draw_line( BLACK, {{c2,r1-1}, {c2, r2}, {c1+1, r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer c1, r1, c2, r2, c, r, center
    integer borderThick, n

    borderThick = 7

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = col1*cWide
    c2 = (col1+wide)*cWide
    r1 = ((row1)*cTall)
    r2 = ((row1+deep-1)*cTall)
    
    -- window
    polygon( WHITE, 1, {{c1-4,r1-18},
                        {c2+4,r1-18},
                        {c2+4,r2+4},
                        {c1-4,r2+4}}) 
                        
    -- window border
    polygon( BLACK, 0, {{c1-5,r1-19},
                        {c2+5,r1-19},
                        {c2+5,r2+5},
                        {c1-5,r2+5}})    
                        
    -- window reflection
    draw_line( BRIGHT_WHITE, {{c1-4,r2+4},
                               {c1-4,r1-18},
                               {c2+4,r1-18}} )
    
    -- window shadow
    draw_line( GRAY, {{c2+4,r1-17},
                              {c2+4,r2+4},
                              {c1-3,r2+4}})

    -- title                               
    center = floor( ((wide)/2) - (length(title)/2) )

    -- title
    graphic_text( row1, col1+center+1, BLACK, WHITE, title )

    -- workspace                        
    polygon( WHITE, 1, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}})    

    -- workspace border
    polygon( GRAY, 0, {{c1-1,r1-1},{c2+1,r1-1},{c2+1,r2+1},{c1-1,r2+1}})    

    -- left and top shadow
    draw_line( GRAY, {{c1-2,r2+1},
                      {c1-2,r1-2},
                      {c2+1,r1-2}})    

    -- right and bottom reflection
    draw_line( BRIGHT_WHITE, {{c2+2,r1-1},
                              {c2+2,r2+2},
                              {c1-1,r2+2}}) 
                                  
    -- left title lines
    c2 = (col1+center)*cWide
    
    for i = 1 to 12 by 2 do
--        draw_line( BRIGHT_WHITE, {{c1+4, r1-16+i},{c2-5, r1-16+i}} )
--        draw_line( GRAY,         {{c1+5, r1-15+i},{c2-4, r1-15+i}} )
        draw_line( BRIGHT_WHITE, {{c1+16, r1-16+i},{c2-5, r1-16+i}} )
        draw_line( GRAY,         {{c1+17, r1-15+i},{c2-4, r1-15+i}} )

    end for
    
    -- right title lines
    c1 = (col1+center+length(title))*cWide
    c2 = (col1+wide)*cWide
    
    for i = 1 to 12 by 2 do
        draw_line( BRIGHT_WHITE, {{c1+4, r1-16+i},{c2-5, r1-16+i}} )
        draw_line( GRAY,         {{c1+5, r1-15+i},{c2-4, r1-15+i}} )
    end for

    -- close box
    b = BLACK
    c1 = col1*cWide    
    r1 = ((row1-1)*cTall)

    pixel( { g,g,g,g,g,g,g,g,g,g,g,g,z }, {c1, r1+0} )
    pixel( { g,b,b,b,b,b,b,b,b,b,b,b,o }, {c1, r1+1} )
    pixel( { g,b,o,z,z,z,z,z,z,z,z,b,o }, {c1, r1+2} )
    pixel( { g,b,z,g,g,g,g,z,z,z,g,b,o }, {c1, r1+3} )
    pixel( { g,b,z,g,g,g,z,z,z,z,g,b,o }, {c1, r1+4} )
    pixel( { g,b,z,g,g,z,z,z,z,z,g,b,o }, {c1, r1+5} )
    pixel( { g,b,z,g,z,z,z,z,z,z,g,b,o }, {c1, r1+6} )
    pixel( { g,b,z,z,z,z,z,z,z,o,g,b,o }, {c1, r1+7} )
    pixel( { g,b,z,z,z,z,z,z,o,o,g,b,o }, {c1, r1+8} )
    pixel( { g,b,z,z,z,z,z,o,o,o,g,b,o }, {c1, r1+9} )
    pixel( { g,b,z,g,g,g,g,g,g,g,g,b,o }, {c1, r1+10} )
    pixel( { g,b,b,b,b,b,b,b,b,b,b,b,o }, {c1, r1+11} )
    pixel( { z,o,o,o,o,o,o,o,o,o,o,o,o }, {c1, r1+12} )

    -- show mouse
    mouse_pointer(1)

end procedure      




