-- dot.ex v.1.1
-- 
-- pre-processor that adds dot notation to Euphoria
--
-- (c) 1998 David Cuny
-- email: dcuny@lanset.com
--

include dot_pp.e

-----------------------------------------------------------------------------
function getFileName()
    -- get the file name from the command line
    -- if none is found, ask the user for it
    
    sequence args, fName

    -- get the command line
    args = command_line()
    if length( args ) > 2 then
        return args[3]
    end if
    
    -- get prompt from user
    puts( 1, "File to link? " )
    fName = gets(0)
    puts( 1, "\n" )
    
    -- remove line feed
    fName = fName[1..length(fName)-1]
    
    -- empty?
    if length( fName ) = 0 then
        abort(0)
    end if   

    return fName
             
end function            


-----------------------------------------------------------------------------
integer handle
sequence inFileName
object result

-- get the file name
    inFileName = getFileName() 

-- preprocess
    result = preprocess( inFileName, 0 )
    if result[1] then
        -- ok
        printf( 1, "Created file %s\n", {result[2]} )
    else  
        -- ex.err
        handle = open( "ex.err", "r" )        
        if handle != -1 then
        
            -- display first 4 lines of ex.err
            for i = 1 to 4 do

                -- read a line       
                result = gets( handle )
                
                -- end of file?
                if integer( result ) then
                    exit
                end if         
                
                puts( 1, result )
                
            end for
            
        end if
        
        -- close the file
        close( handle )
        
    end if

