-- Common Dialog
--  subs_dialog()
--  list procedures in program

include dialog.e    -- dialog tools
include sort.e      -- sort the list

------------------------------------------------------------------------------
function slice( sequence s, integer i1, integer i2 )                          
    -- ensure slice is valid
    if i1 < 1
    or i2 > length( s )
    or i1 > i2 then
        return {}
    else
        return s[i1..i2]
    end if
end function

------------------------------------------------------------------------------
global procedure subs_dialog( sequence text, sequence word )

    sequence list, sList, s
    integer keyPress, n1, n2, pick

    -- intialize the lists
    list = {}       -- names and line numbers
    sList = {}      -- sorted list

    -- gather the list
    for line = 1 to length(text) do
        -- function?
        n1 = match( "function ", text[line] )
        if n1 then    
            -- move past word "function"
            n1 += 9
        else
            -- procedure
            n1 = match( "procedure ", text[line] )
            if n1 then  
                -- move past
                n1 += 10   
            end if
        end if

        if n1 then
            -- find paren
            n2 = match( "(", text[line] )
            -- name should be between these
            s = slice( text[line], n1,n2-1 )
            if length( s ) then
                list  = append( list, {s,line} )
                sList = append( sList, s )
            end if
        end if
    end for

    -- sort the list
    sList = sort( sList )

    -- find match
    pick = 1
    -- word to match
    if length( word ) != 0 then
        -- look through list
        for i = 1 to length( sList ) do
            -- match?
            if compare( sList[i], word ) = 0 then
                -- note position
                pick = i
                exit
            end if
        end for
    end if


    -- put stuff in the box
    new_dialog( "Subroutines", 0, 0, 44, 21, {} )

    -- give them handles
        -- enum PROCS, OK, CANCEL, HELP

    -- controls
        add_control( 1, LIST, "&Choose program item to edit:", 4, 3, 36, 14,
            {PERSIST} )
    
        add_control( 2, BUTTON, "&OK", 19, 2, 8, 0, {DEFAULT_BUTTON, FOCUS} )
        add_control( 3, BUTTON, "&Cancel", 19, 16, 10, 0, {CANCEL_BUTTON} )
        add_control( 4, BUTTON, "&Help", 19, 32, 8, 0, {} )

    -- populate the list
        set_attrib( 1, ITEMS, sList )

    -- need to focus on keyword?
        if pick != 1 then
            -- focus
            set_control( 1, focus_on_list_item( get_control(1), pick ) )
        end if

    -- set up and display the dialog    
    show_dialog()      

    -- run the dialog
    while get_dialog( EXIT_STATE ) = MORE do    -- until the user exits
        edit_dialog()                           -- process keys
        
        if  get_dialog( FOCUS ) = 4                  -- help key?
        and get_dialog( EXIT_STATE ) = OKAYED then
            message_box( "Subs", {
            "List Functions and Procedures in current file.                 ",
            "                                                               ",
            " To go to a Procedure/Function, select the name, and press OK,",
            "  or just double-click the name.                               ",
            "                                                               ",
            " You can press the first letter of the sub/function name to   ",
            "  jump to that part of the list.                               "} )

            set_dialog( EXIT_STATE, MORE )          -- stay in loop

        end if

    end while

    -- ok?
    if get_dialog( EXIT_STATE ) = OKAYED then

        -- selection
        pick = get_attrib( 1, TOP_LINE ) + get_attrib( 1, ITEM ) - 1

        -- get line number
        for i_1 = 1 to length(list) do
            -- match?
            if compare( list[i_1][1], sList[pick] ) = 0 then

                -- go to line number
                edited[fNum][TOP_LINE] = list[i_1][2]
                edited[fNum][ITEM] = 1

                -- remove anchor, if any
                edited[fNum][ANCHOR_COL] = 0

                -- col 1
                edited[fNum][CURSOR] = 1
                edited[fNum][FIRST_CHAR] = 1

            end if
        end for

        -- refresh
            redraw_flag = 1
    end if

    -- restore screen
        hide_dialog()

end procedure


