-- Common Dialog
-- yes_no_dialog()

    -- returns 1 (yes), 0 (no) or -1 (cancelled)

include dialog.e

global function yes_no_dialog( sequence title, sequence prompt )
        
    integer items, col, result

    -- was a single line passed, or multiple lines?
    if atom( prompt[1] ) then

        -- single line
        items = 1

        -- make into list
        prompt = { prompt }

    else
        -- multiple lines
        items = length( prompt )
    end if

    -- put stuff in the box
    new_dialog( title, 0, 0, 60, 5+items, {} )

    -- give them handles
    -- enum YES, NO, CANCEL

    add_control( 1, BUTTON, "&Yes", 3+items, 6, 9, 0, {DEFAULT_BUTTON} )
    add_control( 2, BUTTON, "&No", 3+items, 24, 8, 0, {} )
    add_control( 3, BUTTON, "&Cancel", 3+items, 42, 10, 0, {CANCEL_BUTTON} )

    -- message
    for i = 1 to items do

        -- #n label
        col = floor( (60/2) - ( length( prompt[i] ) / 2 ) )
        add_control( 3+i, LABEL, prompt[i], 1+i, col, 0, 0, {} )

    end for

    -- display the objects
    run_dialog()
    
    -- if pressed ESC, return nothing
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1
    else
        -- which key was pressed?
        if get_dialog( FOCUS ) = 1 then
            result = 1
        else
            result = 0
        end if
    end if

    -- restore screen
    hide_dialog()

    -- return result
    return result

end function

