-- Example #3: Simple Dialog
-- Ask the user if they like pizza
-- Uses loop test instead of run_dialog()
-- Includes "help"


include dialog.e    -- dialog tools
include d_msgbox.e  -- message box

procedure show_help()
        
        -- help for the ask_pizza2() dialog
                
        sequence helpText
                
        helpText = {"Select 'Yes' if you like pizza.",
                    "Select 'No' is you don't like pizza.",
                    "Select 'Cancel' to exit." }
                                
        message_box( "Help", helpText )
        
end procedure

function ask_pizza_3()

    integer result
    
    -- create the dialog
    new_dialog( "Yes or No?", 0, 0, 50, 6, {} )

    -- define controls
    add_control( 1, LABEL,  "Do you like pizza?", 2, 2, 0, 0, {} )
    add_control( 2, BUTTON, "&Yes", 4, 2, 8, 0, {} )
    add_control( 3, BUTTON, "&No", 4, 13, 8, 0, {} )
    add_control( 4, BUTTON, "&Cancel", 4, 24, 10, 0, {CANCEL_BUTTON} )
    add_control( 5, BUTTON, "&Help", 4, 37, 10, 0, {} )
                
    -- initialize dialog    
    show_dialog()      -- set up and display the dialog
                
    -- loop until exit state changes
    while get_dialog( EXIT_STATE ) = MORE do    -- until the user exits
        edit_dialog()                           -- process keys
                                        
        if  get_dialog( EXIT_STATE ) = OKAYED   -- if exited dialog
        and get_dialog( FOCUS ) = 5 then        -- by pressing help button
            show_help()                         -- then show help
            set_dialog( EXIT_STATE, MORE )      -- and reset flag
        end if
                                    
    end while

    -- determine result    
    if get_dialog( EXIT_STATE ) = CANCELLED then
        result = -1     -- pressed Esc or Cancel
    elsif get_dialog( FOCUS ) = 2 then
        result = 1      -- Yes
    else
        result = 0      -- No
    end if             
                        
    -- remove dialog
    hide_dialog()
    
    return result

end function

-- run the code
    integer answer
    answer = ask_pizza_3()

