-- Example of using a Menu
-- This works *without* the dialog tools.

include screen.e        -- screen tools
include menu.e          -- menu routines

-- Menu Definitions

    -- File
    m_bar( 1, "&File" )
    m_item( 1, 1, "&New            ", "Creates a new file" )
    m_item( 1, 2, "&Open           ", "Loads an existing file from disk" )
    m_item( 1, 3, "&Save           ", "Saves current file" )
    m_item( 1, 4, "Save &As...     ", "Saves current file with new name" )
    m_item( 1, 5, "&Close          ", "Closes current file"  )
    m_item( 1, 6, "-", "" )
    m_item( 1, 7, "&Print...       ", ""  )
    m_item( 1, 8, "-", "" )
    m_item( 1, 9, "E&xit           ", "Exits the editor" )

    -- Edit
    m_bar( 2, "&Edit" )
    m_item( 2, 1, "Cu&t       Ctrl+X", "Deletes selected text and copies it to buffer" )
    m_item( 2, 2, "&Copy      Ctrl+C", "Copies selected text to buffer" )
    m_item( 2, 3, "&Paste     Ctrl+V", "Inserts buffer contents at current location" )
    m_item( 2, 4, "Cl&ear     Del   ", "Deletes selected text without copying it to buffer")

    -- Search
    m_bar( 3, "&Search" )
    m_item( 3, 1, "&Find...               ", "Finds specified text" )
    m_item( 3, 2, "Repeat &Last Find    F3", "Finds next occurance of text specified in previous search" )
    m_item( 3, 3, "&Replace...            ", "Finds and changes specified text" )

    -- Help
    m_bar( 4, "&Help" )
    m_item( 4, 1, "&Help...    ", "Help on Menu Demo" )
    m_item( 4, 2, "&About...   ", "About Menu Demo" )



-----------------------------------------------------------------------------
-- Show the Menu
    draw_menu_bar( MAIN_MENU )

-- Key Loop

    integer keyPress, picked

    -- remind user how to exit demo
         position( 3, 1 )
         puts( 1, "Press ESC to exit demo.")


    -- activate mouse
        mouse_pointer(1)
    
    while 1 do
    
        -- wait for a key press
            keyPress = watch_keys()

        -- exit?    
            if keyPress = ESC then
                exit
            end if
            
        -- give to menu      
             picked = give_menu( MAIN_MENU, keyPress )
             position( 4, 1 )
             printf( 1, "Key Press was %g   ", {picked} )
            
    end while

    -- deactivate mouse
        mouse_pointer(1)

    -- restore resolution
        if graphics_mode(-1) then
        end if
