-- gui.e
-- Graphic Interface common tools
-- and load screen

include graphics.e

sequence cursorCovered, cursorWas
cursorCovered = {}


----------------------------------------------------------------------------
global procedure graphic_title( sequence title, sequence colors,
                            integer row, integer col,
                            integer hot, integer is_focus )

    integer x1, y1, x2, y2, color

    -- display title at given position
    -- if there is a "hot" key, underline it
    -- if the text has focus, surround it

    -- hide mouse
    mouse_pointer(0)

    -- the text
    position( row, col )
    put_colors( colors, title )

    -- focus?
    if is_focus then
        color = colors[1]
    else
        color = colors[2]
    end if

    -- "box" around text
    x1 = (col-1)*cWide
    x2 = x1+(length(title)*cWide)
    y1 = ((row-1)*(cTall))
    y2 = y1+cTall
    polygon( color, 0, {{x1-1,y1},{x2,y1},{x2,y2-2},{x1-1,y2-2}} )    


    -- hot key?
    if hot != 0 then
        x1 = x1 + (cWide*(hot-1))
        draw_line( colors[1], {{x1,y2-3},{x1+cWide-1,y2-3}})        
    end if

    -- show mouse
    mouse_pointer(1)

end procedure




----------------------------------------------------------------------------
global procedure show_graphic_cursor()

    sequence curseWide, curseTall, pix
    integer x1, y1, row, col

    -- hide mouse
    mouse_pointer(0)

    -- cursor position
    cursorWas = get_position()
    row = cursorWas[1]
    col = cursorWas[2]

    -- position
    x1 = (col-1)*cWide
    y1 = ((row-1)*(cTall))

    -- get pixels covered by cursor
    cursorCovered = save_clean_image( cursorWas, {row, col+1} )

    -- cursor shape
    if editMode = INSERT_MODE then
        curseWide = { 0, 2 }
        curseTall = { 0, cTall-1 }
    else
        curseWide = { 0, cWide }
        curseTall = { cTall-4, cTall-2 }
    end if

    -- draw cursor
    for wide = curseWide[1] to curseWide[2] do
        for tall = curseTall[1] to curseTall[2] do
            pix = { x1+wide, y1+tall }
            if get_pixel( pix ) = OF_TEXT[1] then
                pixel( OF_TEXT[2], pix )
            else
                pixel( OF_TEXT[1], pix )
            end if
        end for
    end for

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure hide_graphic_cursor()

    integer x1, y1, row, col
    sequence cursorAt

    -- cursor position
    row = cursorWas[1]
    col = cursorWas[2]

    if length( cursorCovered ) > 0 then
        display_clean_image( cursorWas, cursorCovered )
        cursorCovered = {}
    end if
                   
end procedure

-----------------------------------------------------------------------------
-- include the interface of your choice
include plain.e
-- include win31.e
-- include norton.e
-- include win95.e
-- include mac.e
-- include copland.e
-- include os8.e
-- include merlin.e
-- include borland.e
-- include motif.e

