-- Labels for Euphoria

include keys.e          -- key definitions
include graphics.e      -- colors
include wildcard.e      -- upper/lower
include control.e       -- color scheme

----------------------------------------------------------------------------
global function draw_label( sequence label )

    sequence colors, s

	-- alias label

	-- dimmed?
	if label[DIM] then
		colors = { OF_DISABLED[1], OF_DIALOG[2] }
	else
		colors = OF_DIALOG
	end if

	-- location
	position( label[ROW], label[COL] )    

	-- need everything redrawn?
	if label[REDRAW] then

		-- clear flag
		label[REDRAW] = 0

		-- there has to be SOME width
		if label[WIDE] = 0 then 
			label[WIDE] = length( label[TITLE] ) 
		end if


        if length( label[TITLE] ) > label[WIDE] then
            -- trimmed
            s = label[TITLE][1..label[WIDE]]
        else
            -- padded
            s =  label[TITLE] & repeat(   ' ', label[WIDE] - length( label[TITLE] ) )
        end if


		-- display title
        if VGA_MODE then

            -- use graphic routine to display
            graphic_title( s, colors, label[ROW], label[COL], label[HOT], 0 )

        else

            put_colors( colors, s )
	
            -- hot key?
            if label[HOT] > 0 and not label[DIM] then
                -- use color scheme: hotkey foreground, dialog background
                colors = { OF_HOTKEY[1], OF_DIALOG[2] }
     
                -- display
                position( label[ROW], label[COL]+label[HOT]-1 )
                put_colors( colors, { label[TITLE][label[HOT]] } )
            end if

        end if
	end if

    -- return label
    return label

end function

