-- mac.e
-- Classic Macintosh-style controls

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style

constant    b = BLACK,
            w = BRIGHT_WHITE,
            g = WHITE


-- use bright white, not white
    OF_MENUBAR  = { BLACK, BRIGHT_WHITE }
    OF_DIALOG   = { BLACK, BRIGHT_WHITE }
    OF_SELECTED = { BRIGHT_WHITE, BLACK }
    OF_TEXT     = { BLACK, BRIGHT_WHITE }

integer black

object result

-- position of the close box
    CLOSE_BOX_COL = 2

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set black to black
    -- unless dim is true, then set it to gray

    if dim then
        black = GRAY
    else
        black = BLACK
    end if

end procedure
-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
               integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio button

    integer c1, r1, c2, r2, center, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {black, BRIGHT_WHITE}, row, col+3, hot, is_focus )

    -- position of outer circle
    c1 = (col)*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)
    r2 = r1+11

    ellipse( black, 0, {c1, r1}, {c2,r2} )

    -- checked?
    if check then
        color = black
    else
        color = BRIGHT_WHITE
    end if

    -- inner circle
    c1 = c1+3
    c2 = c1+5
    r1 = r1+3
    r2 = r1+5
    
    ellipse( color, 1, {c1, r1}, {c2,r2} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
              integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box

    integer c1, r1, c2, r2, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col)*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)
    r2 = r1+11

    polygon( black, 0, {{c1, r1},{c2,r1},{c2,r2},{c1,r2}} )
    graphic_title( title, {black, BRIGHT_WHITE}, row, col+3, hot, is_focus )

    if check then
        color = black
    else
        color = BRIGHT_WHITE
    end if

    -- the "x"
    draw_line( color, {{c1+1, r1+1},{c2-1,r2-1}} )
    draw_line( color, {{c1+1, r2-1},{c2-1,r1+1}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title, integer col1, integer row1, 
                        integer wide, integer pressed, integer dim,
                        integer hot, integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, fill
    sequence color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

    if pressed then
        fill = 1
        color = { BRIGHT_WHITE, BLACK }
    else
        fill = 0
        color = { black, BRIGHT_WHITE }
    end if

    -- focus?
    if focus then

        -- erase prior

        polygon( BLACK, 1, {{c1-4, r1-4},
                            {c1-4, r2+4},
                            {c2+4, r2+4},
                            {c2+4, r1-4}} )

        polygon( BRIGHT_WHITE, 1, {{c1-1, r1-1},
                            {c1-1, r2+1},
                            {c2+1, r2+1},
                            {c2+1, r1-1}} )


        -- active frame: upper left
            pixel( { w,w,w,w,w,b,b }, {c1-4, r1-4+0} )
            pixel( { w,w,w,b,b,b,b }, {c1-4, r1-4+1} )
            pixel( { w,w,b,b,b,b,b }, {c1-4, r1-4+2} )
            pixel( { w,b,b,b,b,b,w }, {c1-4, r1-4+3} )
            pixel( { w,b,b,b,w,w,w }, {c1-4, r1-4+4} )
            pixel( { b,b,b,b,w,w,w }, {c1-4, r1-4+5} )
            pixel( { b,b,b,w,w,w,w }, {c1-4, r1-4+6} )
    
        -- active frame: upper right
            pixel( { b,b,w,w,w,w,w }, {c2-2, r1-4+0} )
            pixel( { b,b,b,b,w,w,w }, {c2-2, r1-4+1} )
            pixel( { b,b,b,b,b,w,w }, {c2-2, r1-4+2} )
            pixel( { w,b,b,b,b,b,w }, {c2-2, r1-4+3} )
            pixel( { w,w,w,b,b,b,w }, {c2-2, r1-4+4} )
            pixel( { w,w,w,b,b,b,b }, {c2-2, r1-4+5} )
            pixel( { w,w,w,w,b,b,b }, {c2-2, r1-4+6} )
        
        -- active frame: lower left
            pixel( { b,b,b,w,w,w,w }, {c1-4, r2-2+0} )
            pixel( { b,b,b,b,w,w,w }, {c1-4, r2-2+1} )
            pixel( { w,b,b,b,w,w,w }, {c1-4, r2-2+2} )
            pixel( { w,b,b,b,b,b,w }, {c1-4, r2-2+3} )
            pixel( { w,w,b,b,b,b,b }, {c1-4, r2-2+4} )
            pixel( { w,w,w,b,b,b,b }, {c1-4, r2-2+5} )
            pixel( { w,w,w,w,w,b,b }, {c1-4, r2-2+6} )
    
        -- active frame: lower right
            pixel( { w,w,w,w,b,b,b }, {c2-2, r2-2+0} )
            pixel( { w,w,w,b,b,b,b }, {c2-2, r2-2+1} )
            pixel( { w,w,w,b,b,b,w }, {c2-2, r2-2+2} )
            pixel( { w,b,b,b,b,b,w }, {c2-2, r2-2+3} )
            pixel( { b,b,b,b,b,w,w }, {c2-2, r2-2+4} )
            pixel( { b,b,b,b,w,w,w }, {c2-2, r2-2+5} )
            pixel( { b,b,w,w,w,w,w }, {c2-2, r2-2+6} )


    else

        -- erase prior

        polygon( BRIGHT_WHITE, 1, {{c1-4, r1-4},
                            {c1-4, r2+4},
                            {c2+4, r2+4},
                            {c2+4, r1-4}} )
    

    end if

    -- button    
    polygon( black, fill, {{c1,   r1+3},   -- top line
                        {c1,   r2-3},   -- corner
                        {c1+1, r2-2},
                        {c1+1, r2-1},
                        {c1+2, r2-1},
                        {c1+3, r2},
                        {c2-3, r2},     -- right side
                        {c2-2, r2-1},   -- corner
                        {c2-1, r2-1},
                        {c2-1, r2-1},
                        {c2-2, r2-1},
                        {c2,   r2-3},
                        {c2,   r1+3},   -- bottom side
                        {c2-1, r1+2},   -- lower left corner
                        {c2-1, r1+1},
                        {c2-2, r1+1},
                        {c2-3, r1},
                        {c1+3, r1},     -- left side
                        {c1+2, r1+1},   -- upper right corner
                        {c1+1, r1+1},
                        {c1+1, r1+2} } )

    -- title
    center = floor( (wide/2) - (length(title)/2) ) - 1
    graphic_title( title, color, row1, col1+center, hot, 0 )    

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_box( integer row, integer col, integer show )

    integer c, r

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c = col*cWide
    r = row*cTall

    if show = 0 then
        -- erase it
        polygon( w, 1, {{c+1,r},
                            {c+cTall-1,r},
                            {c+cTall-1,r+(cWide*2)},
                            {c+1,r+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    -- box
    polygon( g, 1, {{c,r},
                        {c,r+(cWide*2)},
                        {c+cTall,r+(cWide*2)},
                        {c+cTall,r}} )

    -- BLACK surrounding
    polygon( b, 0, {{c,r},
                        {c,r+(cWide*2)},
                        {c+cTall,r+(cWide*2)},
                        {c+cTall,r}} )


    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    integer c, r

    -- the box
    graphic_box( row, col, show )

end procedure

----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

        -- scroll bar
        polygon( BRIGHT_WHITE, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow

        -- tweak up
        r1 = r1 - 1

        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r1+0} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r1+1} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r1+2} )
        pixel( { b,w,w,w,w,w,w,w,b,w,w,w,w,w,w,w,b }, {c1, r1+3} )
        pixel( { b,w,w,w,w,w,w,b,g,b,w,w,w,w,w,w,b }, {c1, r1+4} )
        pixel( { b,w,w,w,w,w,b,g,g,g,b,w,w,w,w,w,b }, {c1, r1+5} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r1+6} )
        pixel( { b,w,w,w,b,g,g,g,g,g,g,g,b,w,w,w,b }, {c1, r1+7} )
        pixel( { b,w,w,b,g,g,g,g,g,g,g,g,g,b,w,w,b }, {c1, r1+8} )
        pixel( { b,w,b,b,b,b,g,g,g,g,g,b,b,b,b,w,b }, {c1, r1+9} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r1+10} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r1+11} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r1+12} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r1+13} )
        pixel( { b,w,w,w,w,b,b,b,b,b,b,b,w,w,w,w,b }, {c1, r1+14} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r1+15} )
        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r1+16} )


    -- the down arrow

        -- tweak down
        r2=r2-cTall

        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r2+0} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r2+1} )
        pixel( { b,w,w,w,w,b,b,b,b,b,b,b,w,w,w,w,b }, {c1, r2+2} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r2+3} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r2+4} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r2+5} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r2+6} )
        pixel( { b,w,b,b,b,b,g,g,g,g,g,b,b,b,b,w,b }, {c1, r2+7} )
        pixel( { b,w,w,b,g,g,g,g,g,g,g,g,g,b,w,w,b }, {c1, r2+8} )
        pixel( { b,w,w,w,b,g,g,g,g,g,g,g,b,w,w,w,b }, {c1, r2+9} )
        pixel( { b,w,w,w,w,b,g,g,g,g,g,b,w,w,w,w,b }, {c1, r2+10} )
        pixel( { b,w,w,w,w,w,b,g,g,g,b,w,w,w,w,w,b }, {c1, r2+11} )
        pixel( { b,w,w,w,w,w,w,b,g,b,w,w,w,w,w,w,b }, {c1, r2+12} )
        pixel( { b,w,w,w,w,w,w,w,b,w,w,w,w,w,w,w,b }, {c1, r2+13} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r2+14} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r2+15} )
        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r2+16} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall)-1
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( BRIGHT_WHITE, 1,
        {{c1+1,r1+1},{c2-1,r1+1},{c2-1,r2-1},{c1+1,r2-1}})

    --border
    polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}})

    -- shadow
    draw_line( BLACK, {{c2+1,r1+1}, {c2+1, r2+1}, {c1+1, r2+1}} )

    -- show mouse
    mouse_pointer(1)

end procedure      




-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer c1, r1, c2, r2, c, r, center
    integer borderThick, n, m, k

    -- colors
    k = CYAN
    m = BRIGHT_BLUE

    borderThick = 7

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = col1*cWide
    c2 = (col1+wide)*cWide
    r1 = ((row1)*cTall)
    r2 = ((row1+deep-1)*cTall)
    
    -- window
    polygon( BRIGHT_WHITE, 1, {{c1,r1-18},
                        {c2,r1-18},
                        {c2,r2},
                        {c1,r2}}) 
                        
    -- window border
    polygon( BLACK, 0, {{c1-1,r1-19},
                        {c2+1,r1-19},
                        {c2+1,r2},
                        {c1-1,r2}})    

    -- border shadow
    draw_line( BLACK, {{c2+2,r1-17},
                        {c2+2,r2+1},
                        {c1,r2+1}})    


    -- title bar
    polygon( BLACK, 0, {{c1,r1-18},
                        {c2,r1-18},
                        {c2,r1-1},
                        {c1,r1-1}}) 

    -- dividing line
    draw_line( BLACK, {{c1,r1-1},{c2,r1-1}})    

    -- title                               
    center = floor( ((wide)/2) - (length(title)/2) )
    graphic_text( row1, col1+center+1, BLACK, BRIGHT_WHITE, title )

    -- inner border of title
    polygon( m, 0, {{c1+1,r1-17},
                        {c2-1,r1-17},
                        {c2-1,r1-2},
                        {c1+1,r1-2}}) 

    -- workspace border
    draw_line( BLACK, {{c1,r1-1},{c2,r1-1}})    

    -- left title lines
    c2 = (col1+center)*cWide    
    
    for i = 1 to 12 by 2 do
        draw_line( GRAY, {{c1+2, r1-16+i},{c2-2-cWide, r1-16+i}} )
    end for
    
    -- right title lines
    c1 = (col1+center+length(title))*cWide
    c2 = (col1+wide)*cWide
    
    for i = 1 to 12 by 2 do
        draw_line( GRAY, {{c1+2+cWide, r1-16+i},{c2-2, r1-16+i}} )
    end for

    -- close box
    c1 = (col1+1)*cWide    
    r1 = ((row1-1)*cTall)

    pixel( { w,w,w,w,w,w,w,w,w,w,w,w,w }, {c1, r1+0} )
    pixel( { w,m,m,m,m,m,m,m,m,m,m,m,w }, {c1, r1+1} )
    pixel( { w,m,k,k,k,k,k,k,k,k,k,k,w }, {c1, r1+2} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+3} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+4} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+5} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+6} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+7} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+8} )
    pixel( { w,m,k,g,g,g,g,g,g,g,m,k,w }, {c1, r1+9} )
    pixel( { w,m,k,m,m,m,m,m,m,m,m,k,w }, {c1, r1+10} )
    pixel( { w,m,k,k,k,k,k,k,k,k,k,k,w }, {c1, r1+11} )
    pixel( { w,w,w,w,w,w,w,w,w,w,w,w,w }, {c1, r1+12} )

    -- show mouse
    mouse_pointer(1)


    -- show mouse
    mouse_pointer(1)

end procedure      




