-- merlin.e
-- os/2 style widgets


include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style

constant
    g = GRAY,
    w = WHITE,
    o = BRIGHT_WHITE,
    z = WHITE
integer b


-- use black and white
    OF_MENUBAR  = { BLACK, WHITE }
    OF_DIALOG   = { BLACK, WHITE }
    OF_SELECTED = { WHITE, BLACK }
    OF_TEXT     = { BLACK, WHITE }


object result

-- position of close box
    CLOSE_BOX_COL = 2

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color black
    -- gray if dim

    if dim then
        b = GRAY
    else
        b = BLACK
    end if

end procedure


-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
               integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio 

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    c1 = col*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)+1
    r2 = r1+11


    if check then
        pixel( { z,z,z,g,g,g,g,g,g,g,z,z,z }, {c1, r1+0} )
        pixel( { z,z,g,g,o,o,o,o,o,g,g,z,z }, {c1, r1+1} )
        pixel( { z,g,z,o,o,o,z,z,z,z,g,g,z }, {c1, r1+2} )
        pixel( { g,g,o,o,g,b,b,g,z,z,z,g,g }, {c1, r1+3} )
        pixel( { g,o,o,g,b,b,b,b,g,z,z,g,g }, {c1, r1+4} )
        pixel( { g,o,o,b,b,b,b,b,b,z,z,g,g }, {c1, r1+5} )
        pixel( { g,o,z,b,b,b,b,b,b,z,z,g,g }, {c1, r1+6} )
        pixel( { g,o,z,g,b,b,b,b,g,z,g,g,g }, {c1, r1+7} )
        pixel( { g,o,z,z,g,b,b,g,z,z,g,g,g }, {c1, r1+8} )
        pixel( { g,g,z,z,z,z,z,z,z,g,g,g,g }, {c1, r1+9} )
        pixel( { z,g,g,z,z,z,z,g,g,g,g,g,z }, {c1, r1+10} )
        pixel( { z,z,g,g,g,g,g,g,g,g,g,z,z }, {c1, r1+11} )
        pixel( { z,z,z,g,g,g,g,g,g,g,z,z,z }, {c1, r1+12} )


    else
        pixel( { z,z,z,g,g,g,g,g,g,g,z,z,z }, {c1, r1+0} )
        pixel( { z,z,g,g,o,o,o,o,o,g,g,z,z }, {c1, r1+1} )
        pixel( { z,g,z,o,o,o,z,z,z,z,g,g,z }, {c1, r1+2} )
        pixel( { g,g,o,o,z,z,z,z,z,z,z,g,g }, {c1, r1+3} )
        pixel( { g,o,o,z,z,z,z,z,z,z,z,g,g }, {c1, r1+4} )
        pixel( { g,o,o,z,z,z,z,z,z,z,z,g,g }, {c1, r1+5} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+6} )
        pixel( { g,o,z,z,z,z,z,z,z,z,g,g,g }, {c1, r1+7} )
        pixel( { g,o,z,z,z,z,z,z,z,z,g,g,g }, {c1, r1+8} )
        pixel( { g,g,z,z,z,z,z,z,z,g,g,g,g }, {c1, r1+9} )
        pixel( { z,g,g,z,z,z,z,g,g,g,g,g,z }, {c1, r1+10} )
        pixel( { z,z,g,g,g,g,g,g,g,g,g,z,z }, {c1, r1+11} )
        pixel( { z,z,z,g,g,g,g,g,g,g,z,z,z }, {c1, r1+12} )

    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col,
               integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio 

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    c1 = col*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)+1
    r2 = r1+11


    if check then
        pixel( { g,g,g,g,g,g,g,g,g,b,b,g,g }, {c1, r1+0} )
        pixel( { g,o,o,o,o,o,o,o,g,b,g,z,g }, {c1, r1+1} )
        pixel( { g,o,z,z,z,z,z,z,b,b,z,g,g }, {c1, r1+2} )
        pixel( { g,o,z,z,z,z,z,g,b,g,z,g,g }, {c1, r1+3} )
        pixel( { g,o,z,z,z,z,z,b,b,z,z,g,g }, {c1, r1+4} )
        pixel( { g,o,b,b,b,z,g,b,g,z,z,g,g }, {c1, r1+5} )
        pixel( { g,o,z,g,b,b,b,b,z,z,z,g,g }, {c1, r1+6} )
        pixel( { g,o,z,z,g,b,b,g,z,z,z,g,g }, {c1, r1+7} )
        pixel( { g,o,z,z,z,g,b,z,z,z,z,g,g }, {c1, r1+8} )
        pixel( { g,o,z,z,z,z,g,z,z,z,z,g,g }, {c1, r1+9} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+10} )
        pixel( { g,z,g,g,g,g,g,g,g,g,g,g,g }, {c1, r1+11} )
        pixel( { g,g,g,g,g,g,g,g,g,g,g,g,g }, {c1, r1+12} )

    else
        pixel( { g,g,g,g,g,g,g,g,g,g,g,g,g }, {c1, r1+0} )
        pixel( { g,o,o,o,o,o,o,o,o,o,o,z,g }, {c1, r1+1} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+2} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+3} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+4} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+5} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+6} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+7} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+8} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+9} )
        pixel( { g,o,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+10} )
        pixel( { g,z,g,g,g,g,g,g,g,g,g,g,g }, {c1, r1+11} )
        pixel( { g,g,g,g,g,g,g,g,g,g,g,g,g }, {c1, r1+12} )

    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title, integer col1, integer row1, 
                integer wide, integer pressed, integer dim, integer hot,
                integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

    -- button face
    -- overprints because of focus
    polygon( WHITE, 1, {{c1-1,r1-1},{c2+1,r1-1},{c2+1,r2+1},{c1-1,r2+1} } )

    -- title
    center = floor( (wide/2) - (length(title)/2)-1 )
    graphic_title( title, {b, WHITE}, row1, col1+center, hot, is_focus )

    -- focus?
    if focus then

        -- button border
        polygon( GRAY, 0, {{c1, r1}, {c2, r1}, {c2, r2}, {c1, r2} } )

        -- focus
        draw_line( BLACK, {{c1,r1-1}, {c2,r1-1}} )  -- top
        draw_line( BLACK, {{c1,r2+1}, {c2,r2+1}} )  -- bottom
        draw_line( BLACK, {{c1-1,r1}, {c1-1,r2}} )  -- left
        draw_line( BLACK, {{c2+1,r1}, {c2+1,r2}} )  -- right

    else

        -- button border
        draw_line( GRAY, {{c1+1,r1}, {c2-1,r1}} )  -- top
        draw_line( GRAY, {{c1+1,r2}, {c2-1,r2}} )  -- bottom
        draw_line( GRAY, {{c1,r1+1}, {c1,r2-1}} )  -- left
        draw_line( GRAY, {{c2,r1+1}, {c2,r2-1}} )  -- right

    end if

    -- top reflection
    if pressed then
        color = GRAY
    else
        color = BRIGHT_WHITE
    end if

    draw_line( color, { {c1+1, r2-1}, {c1+1, r1+1}, {c2-1, r1+1} } )

    -- bottom shadow    
    if pressed then
        color = BRIGHT_WHITE
    else
        color = GRAY
    end if

    draw_line( color, {{c2-1, r1+2}, {c2-1, r2-1}, {c1+1, r2-1}} )
    
    -- show mouse
    mouse_pointer(1)
    
end procedure


-----------------------------------------------------------------------------
global procedure graphic_box( integer row, integer col, integer show )

    integer c, r

    -- convert to points
    c = col*cWide
    r = (row+1)*cTall

    -- hide mouse
    mouse_pointer(0)

    if show then

        draw_line( BRIGHT_WHITE, {  {c+1,r-2},
                                    {c+1,r-(cTall-1)},
                                    {c+(cWide*2)-2,r-(cTall-1)}} )

        draw_line( GRAY, { {c+(cWide*2)-1,r-(cTall)+2},
                           {c+(cWide*2)-1,r-1},
                           {c+2,r-1} } )

    else

        -- erase old
        polygon( WHITE, 1, {    {c+1,r-1},
                                {c+1,r-(cTall)},
                                {c+(cWide*2)-1,r-(cTall)},
                                {c+(cWide*2)-1,r-1} } )

    end if

    -- show mouse
    mouse_pointer(1)

end procedure


----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    -- call graphic box
    graphic_box( row, col, show )

end procedure

----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        draw_line( GRAY, {{c1,r2},{c1,r1},{c2,r1},{c2,r2}} )
        draw_line( BRIGHT_WHITE, {{c2,r1},{c2,r2},{c1,r2}} )


        -- scroll bar
        polygon( WHITE, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow
        -- box
        graphic_box( row, col-1, 1 )

        -- up arrow
        pixel( { z,z,z,o,z,z,z }, {c1+5, r1+6} )
        pixel( { z,z,o,o,o,z,z }, {c1+5, r1+7} )
        pixel( { z,o,o,z,o,o,z }, {c1+5, r1+8} )
        pixel( { o,o,z,z,z,o,o }, {c1+5, r1+9} )

    -- the down arrow
        -- box
        graphic_box( row+deep-1, col-1, 1 )
    
        -- down arrow
        pixel( { o,o,z,z,z,o,o }, {c1+5, r2-cTall+6} )
        pixel( { z,o,o,z,o,o,z }, {c1+5, r2-cTall+7} )
        pixel( { z,z,o,o,o,z,z }, {c1+5, r2-cTall+8} )
        pixel( { z,z,z,o,z,z,z }, {c1+5, r2-cTall+9} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        draw_line( GRAY, {{c1,r2},{c1,r1},{c2,r1},{c2,r2}} )
        draw_line( BRIGHT_WHITE, {{c2,r1},{c2,r2},{c1,r2}} )


    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- draw a slab

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall) 
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{c1,r1-2},{c2,r1-2},{c2,r2},{c1,r2}})

    -- reflection
    draw_line( BRIGHT_WHITE, {{c1+1, r2-1}, {c1+1, r1-1}, {c2, r1-1}} )

    -- facet shadow
    draw_line( GRAY, {{c2-1, r1-1}, {c2-1, r2-1}, {c1+1, r2-1}} )

    -- shadow
    draw_line( BLACK, {{c2,r1-1}, {c2, r2}, {c1+1, r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer c1, r1, c2, r2, c, r, center
    integer n

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = col1*cWide-1
    c2 = (col1+wide)*cWide
    r1 = ((row1)*cTall)
    r2 = ((row1+deep-1)*cTall)

    -- window
    polygon( WHITE, 1, {{c1-4,r1-(18+5)},
                        {c2+4,r1-(18+5)},
                        {c2+4,r2+4},
                        {c1-4,r2+4}}) 
                        
    -- window border
    polygon( BLACK, 0, {{c1-5,r1-(18+4+1)},
                        {c2+5,r1-(18+4+1)},
                        {c2+5,r2+5},
                        {c1-5,r2+5}})    
                        
    -- window reflection
    draw_line( BRIGHT_WHITE, {{c1-4,r2+3},
                               {c1-4,r1-(18+5)},
                               {c2+4,r1-(18+5)}} )
    
    -- window shadow
    draw_line( GRAY, {{c2+4,r1-(18+4)},
                              {c2+4,r2+4},
                              {c1-3,r2+4}})
                              
    -- workspace border
    draw_line( GRAY, {{c1,r2},{c1,r1-18},{c2,r1-18}})    
    draw_line( BRIGHT_WHITE, {{c2,r1-18},{c2,r2},{c1,r2}})

    -- title text
    graphic_text( row1, col1+4, BRIGHT_WHITE, WHITE, title )

    -- title border
    draw_line( BRIGHT_WHITE, {{c1+1,r1-1},{c1+1,r1-(17)},{c2-1,r1-(17)}})    
    draw_line( GRAY, {{c2-1,r1-(17)},{c2-1,r1-1},{c1+1,r1-1}})

    -- close button edge
    draw_line( GRAY, {{c1+17,r1-(18-2)},{c1+17,r1-1}})

    -- close box
    b = BLACK
    c1 = col1*cWide    
    r1 = ((row1-1)*cTall)

    pixel( { b,b,z,z,z,b,b }, {c1+6, r1+5} )
    pixel( { z,b,b,z,b,b,z }, {c1+6, r1+6} )
    pixel( { z,z,b,b,b,z,z }, {c1+6, r1+7} )
    pixel( { z,z,z,b,z,z,z }, {c1+6, r1+8} )
    pixel( { z,z,z,z,z,z,z }, {c1+6, r1+9} )
    pixel( { b,b,b,b,b,b,b }, {c1+6, r1+10} )

    -- show mouse
    mouse_pointer(1)

end procedure      




