-- Motif Style widgets

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style


constant    w = BRIGHT_WHITE,
            z = WHITE,
            g = GRAY,
            b = BLACK

integer black

object result

-- position of the close box
    CLOSE_BOX_COL = 2

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color for black
    -- gray if dim

    if dim then
        black = GRAY
    else
        black = BLACK
    end if

end procedure


-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
                integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio button, borland/c-windows

    integer c1, r1
    
    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {black, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    c1 = (col)*cWide
    r1 = ((row-1)*cTall)

    if check then
        pixel( { z,z,z,z,z,z,g,z,z,z,z,z,z }, {c1, r1+0} )
        pixel( { z,z,z,z,z,g,g,w,z,z,z,z,z }, {c1, r1+1} )
        pixel( { z,z,z,z,g,g,z,w,w,z,z,z,z }, {c1, r1+2} )
        pixel( { z,z,z,g,g,z,z,z,w,w,z,z,z }, {c1, r1+3} )
        pixel( { z,z,g,g,z,z,b,z,z,w,w,z,z }, {c1, r1+4} )
        pixel( { z,g,g,z,z,b,b,b,z,z,w,w,z }, {c1, r1+5} )
        pixel( { g,g,z,z,b,b,b,b,b,z,z,w,w }, {c1, r1+6} )
        pixel( { z,g,g,z,z,b,b,b,z,z,w,w,z }, {c1, r1+7} )
        pixel( { z,z,g,g,z,z,b,z,z,w,w,z,z }, {c1, r1+8} )
        pixel( { z,z,z,g,g,z,z,z,w,w,z,z,z }, {c1, r1+9} )
        pixel( { z,z,z,z,g,g,z,w,w,z,z,z,z }, {c1, r1+10} )
        pixel( { z,z,z,z,z,g,w,w,z,z,z,z,z }, {c1, r1+11} )
        pixel( { z,z,z,z,z,z,w,z,z,z,z,z,z }, {c1, r1+12} )

    else
        pixel( { z,z,z,z,z,z,w,z,z,z,z,z,z }, {c1, r1+0} )
        pixel( { z,z,z,z,z,w,w,g,z,z,z,z,z }, {c1, r1+1} )
        pixel( { z,z,z,z,w,w,z,g,g,z,z,z,z }, {c1, r1+2} )
        pixel( { z,z,z,w,w,z,z,z,g,g,z,z,z }, {c1, r1+3} )
        pixel( { z,z,w,w,z,z,z,z,z,g,g,z,z }, {c1, r1+4} )
        pixel( { z,w,w,z,z,z,z,z,z,z,g,g,z }, {c1, r1+5} )
        pixel( { w,w,z,z,z,z,z,z,z,z,z,g,g }, {c1, r1+6} )
        pixel( { z,w,w,z,z,z,z,z,z,z,g,g,z }, {c1, r1+7} )
        pixel( { z,z,w,w,z,z,z,z,z,g,g,z,z }, {c1, r1+8} )
        pixel( { z,z,z,w,w,z,z,z,g,g,z,z,z }, {c1, r1+9} )
        pixel( { z,z,z,z,w,w,z,g,g,z,z,z,z }, {c1, r1+10} )
        pixel( { z,z,z,z,z,w,g,g,z,z,z,z,z }, {c1, r1+11} )
        pixel( { z,z,z,z,z,z,g,z,z,z,z,z,z }, {c1, r1+12} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
procedure draw_slab( integer color, integer direction, integer c1, integer r1,
                        integer c2, integer r2 )

    integer color1, color2

    if direction = 0 then
        color1 = BRIGHT_WHITE
        color2 = BLACK
    else
        color1 = BLACK
        color2 = BRIGHT_WHITE
    end if

    -- filled poly
    polygon( color, 1, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}})

    -- highlights
    draw_line( color1, {{c1,r2},{c1,r1},{c2,r1}})
    draw_line( color1, {{c1+1,r2-1},{c1+1,r1+1},{c2-1,r1+1}})


    -- shadow
    draw_line( color2, {{c2,r1},{c2,r2},{c1,r2}})
    draw_line( color2, {{c2-1,r1+1},{c2-1,r2-1},{c1+1,r2-1}})

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
                 integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box, motif style

    integer c1, r1, c2, r2, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col)*cWide
    c2 = c1+12
    r1 = ((row-1)*cTall)
    r2 = r1+12

    graphic_title( title, {black, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    draw_slab( WHITE, check, c1, r1, c2, r2 )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title,
                integer col1, integer row1, integer wide, integer pressed,
                integer dim, integer hot, integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, color

    -- dimmed?
    set_black( dim )

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

    -- button
    draw_slab( WHITE, pressed, c1+3, r1-3, c2-3, r2+3 )

    -- title
    center = floor( (wide/2) - (length(title)/2)-1 )
    graphic_title( title, {black, WHITE}, row1, col1+center, hot, is_focus )

    -- focus?
    if focus then
        color = BLACK
    else
        color = WHITE
    end if

    -- show mouse
    mouse_pointer(1)
    
end procedure


-----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    -- a "thumb" is 17x17 pixels

    integer c, r

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c = col*cWide
    r = row*cTall

    if show = 0 then
        -- erase it
        polygon( GRAY, 1, {{c+1,r},
                            {c+cTall-1,r},
                            {c+cTall-1,r+(cWide*2)},
                            {c+1,r+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    draw_slab( WHITE, 0, c+1, r+1, c+cTall-1, r+(cWide*2)-2 )

    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{c1,r2},{c2,r1},{c2,r2},{c1,r2}} )

        -- scroll bar
        polygon( GRAY, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow

        -- tweak up
        r1 = r1 - 1

        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r1+0} )
        pixel( { b,g,g,g,g,g,g,g,w,g,g,g,g,g,g,g,b }, {c1, r1+1} )
        pixel( { b,g,g,g,g,g,g,w,z,b,g,g,g,g,g,g,b }, {c1, r1+2} )
        pixel( { b,g,g,g,g,g,g,w,z,b,g,g,g,g,g,g,b }, {c1, r1+3} )
        pixel( { b,g,g,g,g,g,w,z,z,z,b,g,g,g,g,g,b }, {c1, r1+4} )
        pixel( { b,g,g,g,g,g,w,z,z,z,b,g,g,g,g,g,b }, {c1, r1+5} )
        pixel( { b,g,g,g,g,w,z,z,z,z,z,b,g,g,g,g,b }, {c1, r1+6} )
        pixel( { b,g,g,g,g,w,z,z,z,z,z,b,g,g,g,g,b }, {c1, r1+7} )
        pixel( { b,g,g,g,w,z,z,z,z,z,z,z,b,g,g,g,b }, {c1, r1+8} )
        pixel( { b,g,g,g,w,z,z,z,z,z,z,z,b,g,g,g,b }, {c1, r1+9} )
        pixel( { b,g,g,w,z,z,z,z,z,z,z,z,z,b,g,g,b }, {c1, r1+10} )
        pixel( { b,g,g,w,z,z,z,z,z,z,z,z,z,b,g,g,b }, {c1, r1+11} )
        pixel( { b,g,w,z,z,z,z,z,z,z,z,z,z,z,b,g,b }, {c1, r1+12} )
        pixel( { b,g,w,z,z,z,z,z,z,z,z,z,z,z,b,g,b }, {c1, r1+13} )
        pixel( { b,w,z,z,z,z,z,z,z,z,z,z,z,z,z,b,b }, {c1, r1+14} )
        pixel( { b,w,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r1+15} )
        pixel( { b,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,b }, {c1, r1+16} )


    -- the down arrow

        -- tweak down
        r2=r2-cTall

        pixel( { b,g,g,g,g,g,g,g,g,g,g,g,g,g,g,g,b }, {c1, r2+0} )
        pixel( { b,w,w,w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r2+1} )
        pixel( { b,w,z,z,z,z,z,z,z,z,z,z,z,z,z,b,b }, {c1, r2+2} )
        pixel( { b,g,w,z,z,z,z,z,z,z,z,z,z,z,b,g,b }, {c1, r2+3} )
        pixel( { b,g,w,z,z,z,z,z,z,z,z,z,z,z,b,g,b }, {c1, r2+4} )
        pixel( { b,g,g,w,z,z,z,z,z,z,z,z,z,b,g,g,b }, {c1, r2+5} )
        pixel( { b,g,g,w,z,z,z,z,z,z,z,z,z,b,g,g,b }, {c1, r2+6} )
        pixel( { b,g,g,g,w,z,z,z,z,z,z,z,b,g,g,g,b }, {c1, r2+7} )
        pixel( { b,g,g,g,w,z,z,z,z,z,z,z,b,g,g,g,b }, {c1, r2+8} )
        pixel( { b,g,g,g,g,w,z,z,z,z,z,b,g,g,g,g,b }, {c1, r2+9} )
        pixel( { b,g,g,g,g,w,z,z,z,z,z,b,g,g,g,g,b }, {c1, r2+10} )
        pixel( { b,g,g,g,g,g,w,z,z,z,b,g,g,g,g,g,b }, {c1, r2+11} )
        pixel( { b,g,g,g,g,g,w,z,z,z,b,g,g,g,g,g,b }, {c1, r2+12} )
        pixel( { b,g,g,g,g,g,g,w,z,b,g,g,g,g,g,g,b }, {c1, r2+13} )
        pixel( { b,g,g,g,g,g,g,w,z,b,g,g,g,g,g,g,b }, {c1, r2+14} )
        pixel( { b,g,g,g,g,g,g,g,b,g,g,g,g,g,g,g,b }, {c1, r2+15} )
        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r2+16} )

    -- show mouse
    mouse_pointer(1)

end procedure




-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        draw_slab( WHITE, 1, c1, r1, c2, r2 )


    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall)-1
    r2 = ((row1+deep-1)*cTall)+2
    
    draw_slab( WHITE, 0, c1, r1, c2, r2 )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer r1, c1, r2, c2, r, c, center
    integer n, m

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = col1*cWide-1
    c2 = (col1+wide-1)*cWide+1
    r1 = ((row1-1)*cTall) - 3
    r2 = ((row1+deep-1)*cTall)+1
    
    -- window              
    draw_slab( color, 0, c1-5, r1-5, c2+5, r2+cTall+6 )

    -- title
    draw_slab( color, 0, c1+21, r1, c2, r1+cTall+4 )

    -- close box
    draw_slab( color, 0, c1, r1, c1+19, r1+cTall+4 )

    -- close button
    draw_slab( color, 0, c1+5, r1+(cTall/2)-2, c1+15, r1+(cTall/2)+6 )

    -- inner frame
    draw_slab( WHITE, 1, c1, r1+cTall+6, c2, r2 )
            
    -- center = floor( ((wide)/2) - (length(title)/2) )
    graphic_text( row1, col1+5, BRIGHT_WHITE, color, title )

    -- show mouse
    mouse_pointer(1)

end procedure      



