-- Win3.1 Style widgets
-- "Norton" style 3-D look

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

integer black

object result

-- close box position
    CLOSE_BOX_COL = 2

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color for black
    -- gray if dim

    if dim then
        black = GRAY
    else
        black = BLACK
    end if

end procedure


-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
                integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio button

    integer c1, r1, c2, r2, center, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )
        
    -- the title
    graphic_title( title, {black, WHITE}, row, col+3, hot, is_focus )

    -- position of outer circle
    c1 = (col)*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)
    r2 = r1+11

    ellipse( black, 0, {c1, r1}, {c2,r2} )

    -- checked?
    if check then
        color = black
    else
        color = WHITE
    end if

    -- inner circle
    c1 = c1+3
    c2 = c1+5
    r1 = r1+3
    r2 = r1+5
    
    ellipse( color, 1, {c1, r1}, {c2,r2} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
                 integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box

    integer c1, r1, c2, r2, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col)*cWide
    c2 = c1+11
    r1 = ((row-1)*cTall)
    r2 = r1+11

    polygon( BLACK, 0, {{c1, r1},{c2,r1},{c2,r2},{c1,r2}} )
    graphic_title( title, {black, WHITE}, row, col+3, hot, is_focus )

    if check then
        color = black
    else
        color = WHITE
    end if

    -- the "c"
    draw_line( color, {{c1+1, r1+1},{c2-1,r2-1}} )
    draw_line( color, {{c1+1, r2-1},{c2-1,r1+1}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title,
                integer col1, integer row1, integer wide, integer pressed,
                integer dim, integer hot, integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, color

    -- dimmed?
    set_black( dim )

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

    -- face of button
    polygon( WHITE, 1, {  {c1+3,r1+3},      -- upper left
                            {c2-3,r1+3},    -- upper right
                            {c2-3,r2-3},    --lower right
                            {c1+3,r2-3}})   -- lower left

    -- title
    center = floor( (wide/2) - (length(title)/2)-1 )
    graphic_title( title, {black, WHITE}, row1, col1+center, hot, is_focus )

    -- single border
    draw_line( BLACK, {{c1, r1+1}, {c1, r2-1}} )
    draw_line( BLACK, {{c2, r1+1}, {c2, r2-1}} )
    draw_line( BLACK, {{c1+1,r1}, {c2-1,r1}} ) 
    draw_line( BLACK, {{c1+1,r2}, {c2-1,r2}} )
        
    -- focus?
    if focus then
        color = BLACK
    else
        color = WHITE
    end if

    draw_line( color, {{c1-1, r1}, {c1-1, r2}} )
    draw_line( color, {{c2+1, r1}, {c2+1, r2}} )
    draw_line( color, {{c1,r1-1}, {c2,r1-1}} ) 
    draw_line( color, {{c1,r2+1}, {c2,r2+1}} )
    pixel( color, {c1, r1} )
    pixel( color, {c1, r2} )
    pixel( color, {c2, r1} )
    pixel( color, {c2, r2} )


    -- top reflection
    if pressed then
        color = GRAY
    else
        color = BRIGHT_WHITE
    end if
    
    draw_line( color, {{c1+1, r1+1}, {c2-1, r1+1}} )
    draw_line( color, {{c1+1, r1+2}, {c2-1, r1+2}} )    
    
    -- left reflection
    draw_line( color, {{c1+1, r1+3}, {c1+1, r2-1}} )
    draw_line( color, {{c1+2, r1+3}, {c1+2, r2-1}} )
    
    if pressed then
        color = WHITE
    else
        color = GRAY
    end if

    -- bottom shadow    
    draw_line( color, {{c1+3, r2-2}, {c2-1, r2-2}} )
    draw_line( color, {{c1+2, r2-1}, {c2-1, r2-1}} )

    -- right shadow    
    draw_line( color, {{c2-2, r1+2}, {c2-2, r2-3}} )
    draw_line( color, {{c2-1, r1+1}, {c2-1, r2-3}} )
    
    -- show mouse
    mouse_pointer(1)
    
end procedure


-----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    -- a "thumb" is 17x17 pixels

    integer c, r

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c = col*cWide
    r = row*cTall

    if show = 0 then
        -- erase it
        polygon( WHITE, 1, {{c+1,r},
                            {c+cTall-1,r},
                            {c+cTall-1,r+(cWide*2)},
                            {c+1,r+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    -- BLACK surrounding
    polygon( BLACK, 0, {{c,r},
                        {c,r+(cWide*2)},
                        {c+cTall,r+(cWide*2)},
                        {c+cTall,r}} )
    
    -- top reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+cTall-1,r+1}})
    
    -- left reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+1,r+(cWide*2)-2}})    
    
    -- bottom shadow
    draw_line( GRAY, {{c+2,r+(cWide*2)-2},{c+cTall-2,r+(cWide*2)-2}})    
    draw_line( GRAY, {{c+1,r+(cWide*2)-1},{c+cTall-2,r+(cWide*2)-1}})    
    
    -- right shadow
    draw_line( GRAY, {{c+cTall-2,r+2},{c+cTall-2,r+(cWide*2)-1}})
    draw_line( GRAY, {{c+cTall-1,r+1},{c+cTall-1,r+(cWide*2)-1}})
    
    -- face
    polygon( WHITE, 1, {{c+2,r+2},
                        {c+cTall-3,r+2},
                        {c+cTall-3,r+(cWide*2)-3},
                        {c+2,r+(cWide*2)-3}} )

    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

        -- scroll bar
        polygon( WHITE, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow
        -- box
        graphic_thumb( row, col-1, 1 )

        -- up arrow
        polygon( BLACK, 1, {{c1+8,r1+4},{c1+8-3,r1+4+3},{c1+8+3,r1+4+3}} )
        polygon( BLACK, 1, {{c1+7,r1+8},
                            {c1+7+2,r1+8},
                            {c1+7+2,r1+8+2},
                            {c1+7,r1+8+2}})

    -- the down arrow
        -- box
        graphic_thumb( row+deep-1, col-1, 1 )
    
        -- convert to points
        r1 = (row+deep-1)*cTall
    
        -- down arrow
        polygon( BLACK, 1, {{c1+7,r1+5},
                            {c1+7+2,r1+5},
                            {c1+7+2,r1+5+2},
                            {c1+7,r1+5+2}})
        polygon( BLACK, 1, {{c1+8,r1+11},
                            {c1+8-3,r1+11-3},
                            {c1+8+3,r1+11-3}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall)-1
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{c1+1,r1+1},{c2-1,r1+1},{c2-1,r2-1},{c1+1,r2-1}})

    --border
    polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}})

    -- shadow
    draw_line( BLACK, {{c2+1,r1+1}, {c2+1, r2+1}, {c1+1, r2+1}} )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer c1, r1, c2, r2, c, r, center
    integer n, tall

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = col1*cWide
    c2 = (col1+wide-1)*cWide
    r1 = ((row1-1)*cTall) - 3
    r2 = ((row1+deep-1)*cTall)

    -- window
    polygon( WHITE, 1, {{c1-4,r1-4},{c2+4,r1-4},{c2+4,r2+4},{c1-4,r2+4}})

    -- reflection & shadow
    draw_line( BRIGHT_WHITE, {{c1-3,r2+3},{c1-3,r1-3},{c2+3,r1-3}})
    draw_line( GRAY, {{c2+3,r1-3},{c2+3,r2+3},{c1-3,r2+3}})
    draw_line( BLACK, {{c2+4,r1-4},{c2+4,r2+4},{c1-4,r2+4}})
    
    -- title bar
    -- the 18 omits the "close" box
    polygon( color, 1, {{c1+1,r1},
                        {c2-3,r1},
                        {c2-3,r1+18},
                        {c1+1,r1+18}})

    -- title text
    center = floor( ((wide)/2) - (length(title)/2) )
    graphic_text( row1, col1+center, BRIGHT_WHITE, color, title )

    -- reflection around title
    draw_line( BLACK, {{c1+1,r1+18}, {c1+1,r1}, {c2-3,r1} } )
    draw_line( BRIGHT_WHITE, {{c2-3,r1},{c2-3,r1+18},{c1+1,r1+18}})

    -- the close box
    polygon( WHITE, 1, {{c1+2,r1+1},
                        {c1+18,r1+1},
                        {c1+18,r1+17},
                        {c1+2,r1+17}})

    draw_line( BRIGHT_WHITE, {{c1+18,r1+1},{c1+18,r1+17}} )

    -- close "button"
    polygon( BLACK, 0, {{c1+4,r1+8},
                        {c1+4,r1+10},
                        {c1+15,r1+10},
                        {c1+15,r1+8}})

    -- button
    draw_line( BRIGHT_WHITE, {{c1+5,r1+9},{c1+14,r1+9}} )

    -- shadow
    draw_line( GRAY, {{c1+5,r1+11},{c1+16,r1+11},{c1+16,r1+9}} )
    
    -- show mouse
    mouse_pointer(1)

end procedure      

