-- pre.e
-- Run Euphoria pre-processor from inside editor

include pp.e        -- Euphoria pre-processor

-----------------------------------------------------------------------------
global procedure editor_preprocess()

    integer     handle, dotAt
    sequence    fileName, outFileName, fileData, extension

	-- convert the file; returns the file name of the new file

    -- convert .PP and .P into .EX and .E
    fileName = upper( edited[fNum][TITLE] )
    
    -- split into extension, if any
    dotAt = match( ".", fileName )
    if dotAt = 0 then

        -- error
        message_box( "Pre-Processor",
            "File name must end with '.PP' or '.P'" )

        return

    else

        -- get extension
            extension = fileName[dotAt..length(fileName)]
            fileName = fileName[1..dotAt-1]

        -- convert preprocessor extensions
        if compare( ".PP", extension ) = 0 then

            -- .PP converts to .EX
            outFileName = fileName & ".EX"

        elsif compare( ".P", extension ) = 0 then

            -- .P converts to .E
            outFileName = fileName & ".E"

        else

            -- error
            message_box( "Pre-Processor",
                "File name must end with '.PP' or '.P'" )

            return

        end if

    end if


	-- clear the error message
		errText = ""
		errLine = 0

    -- parse the file. parm #3 is "quiet" mode.
            convertFile( edited[fNum][ITEMS], outFileName, 0 )

	-- error message?
		if compare( errText, "" ) != 0 then

			-- write to the err file, if file opened
				if errLine > 0 then
					-- open file
						handle = open( "ex.err", "w" )

					-- file name and line number
						printf( handle, "%s:%g\n", {outFileName,errLine} )

					-- error message
						puts( handle, "Pre-processor error - " &
							errText & "\n" )

					-- line, if any
                        if errLine <= length( edited[fNum][ITEMS] ) then
                            puts( handle, edited[fNum][ITEMS][errLine]
                                        & "\n" )
						end if

					-- close the file
						close( handle )

				end if

		else
            message_box( "Pre-processor",
                "Created output file '" & outFileName & "'." )
		end if

end procedure
