-- screen.e
--
-- support tools for screen writes
-- this calls one of the screens based on the requested
-- screen resolution:
--
--  text mode                       - textmode.e
--  mode 18 (16 colors)             - vgamode.e
--  mode 19 or 57 (256 colors)      - svgamode.e

-- Thanks to:
--  Tom Riso for *major* help
--  Pete Eberlein for SVGA mode support

without warning
with trace

global constant INTENSE = 8     -- add to colors for intense
global integer SCREEN_WIDE      -- screen width
global integer SCREEN_DEEP      -- screen depth
global integer SCREEN_MEMORY    -- screen video memory start
global integer cTall, cWide

include machine.e   -- bios calls
include graphics.e  -- colors
include image.e     -- writing to screen
include keys.e      -- hide cursor
include ports.e     -- reading/writing ports

----------------------------------------------------------------------------
-- Tools for deferred displaying

global integer defer_display_flag       -- write to buffer, not screen
global sequence defer_display_buffer    -- buffer to write to
                defer_display_flag = 0          -- turn it off

----------------------------------------------------------------------------

-- set resolution
--
--  text mode   = 0
--  VGA         = 18
--  SVGA        = 19 or 257

-- load support tools

    include textmode.e         -- text mode
    -- include vgamode.e       -- mode 18
    -- include svgamode.e      -- mode 19 or 257


-- turn on intense colors
    toggle_blinking(0)

