-- Win95 Style widgets

include graphics.e
include machine.e
include get.e        
include mouse.e
include screen.e

without warning
with trace

constant    W_DIALOG = 0,   -- dialog style
            W_NORMAL = 1    -- normal style


-- colors for controls
-- black is not a constant because it can be dimmed
constant    z = WHITE,
            r = GRAY,
            w = BRIGHT_WHITE,
            g = GRAY

integer b
    b = BLACK

object result

-- position of close box
    CLOSE_BOX_COL = -3

-----------------------------------------------------------------------------
procedure set_black( integer dim )

    -- set color for black
    -- gray if dim

    if dim then
        b = GRAY
    else
        b = BLACK
    end if

end procedure

-----------------------------------------------------------------------------
global procedure graphic_radio( sequence title,  integer row, integer col,
            integer check, integer dim, integer hot, integer is_focus )

    -- draw a radio 

    integer c1, r1
    
    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- the title
    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    -- convert to points
    c1 = (col)*cWide-1
    r1 = ((row-1)*cTall)

    if check then
        pixel( { z,z,z,z,r,r,r,r,z,z,z,z,z }, {c1, r1+0} )
        pixel( { z,z,r,b,b,b,b,b,b,r,z,z,z }, {c1, r1+1} )
        pixel( { z,r,b,r,w,w,w,w,w,b,r,z,z }, {c1, r1+2} )
        pixel( { z,b,r,w,w,r,r,r,w,w,r,z,z }, {c1, r1+3} )
        pixel( { r,b,w,w,b,b,b,b,b,w,w,r,g }, {c1, r1+4} )
        pixel( { r,b,w,r,b,b,b,b,b,r,w,r,g }, {c1, r1+5} )
        pixel( { r,b,w,r,b,b,b,b,b,r,w,r,g }, {c1, r1+6} )
        pixel( { r,b,w,r,b,b,b,b,b,r,w,r,g }, {c1, r1+7} )
        pixel( { z,b,w,w,b,b,b,b,b,w,w,r,g }, {c1, r1+8} )
        pixel( { z,r,b,w,w,r,r,r,w,w,r,g,z }, {c1, r1+9} )
        pixel( { z,z,r,r,w,w,w,w,w,r,z,g,z }, {c1, r1+10} )
        pixel( { z,z,z,z,r,r,r,r,r,g,g,z,z }, {c1, r1+11} )
        pixel( { z,z,z,z,g,g,g,g,g,z,z,z,z }, {c1, r1+12} )
    else
        pixel( { z,z,z,z,r,r,r,r,z,z,z,z,z }, {c1, r1+0} )
        pixel( { z,z,r,b,b,b,b,b,b,r,z,z,z }, {c1, r1+1} )
        pixel( { z,r,b,r,w,w,w,w,w,b,r,z,z }, {c1, r1+2} )
        pixel( { z,b,r,w,w,w,w,w,w,w,r,z,z }, {c1, r1+3} )
        pixel( { r,b,w,w,w,w,w,w,w,w,w,r,g }, {c1, r1+4} )
        pixel( { r,b,w,w,w,w,w,w,w,w,w,r,g }, {c1, r1+5} )
        pixel( { r,b,w,w,w,w,w,w,w,w,w,r,g }, {c1, r1+6} )
        pixel( { r,b,w,w,w,w,w,w,w,w,w,r,g }, {c1, r1+7} )
        pixel( { z,b,w,w,w,w,w,w,w,w,w,r,g }, {c1, r1+8} )
        pixel( { z,r,b,w,w,w,w,w,w,w,r,g,z }, {c1, r1+9} )
        pixel( { z,z,r,r,w,w,w,w,w,r,z,g,z }, {c1, r1+10} )
        pixel( { z,z,z,z,r,r,r,r,r,g,g,z,z }, {c1, r1+11} )
        pixel( { z,z,z,z,g,g,g,g,g,z,z,z,z }, {c1, r1+12} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_check( sequence title,  integer row, integer col, 
              integer check, integer dim, integer hot, integer is_focus )

    -- draw a check box

    integer c1, r1, c2, r2, color

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c1 = (col)*cWide
    c2 = c1+12
    r1 = ((row-1)*cTall)
    r2 = r1+12

    -- dimmed?
    set_black( dim )

    graphic_title( title, {b, WHITE}, row, col+3, hot, is_focus )

    draw_line( GRAY, {{c1,r1+11},{c1,r1},{c1+11,r1}} )
    polygon( BRIGHT_WHITE, 1, {{c1+2, r1+1},{c2,r1+2},{c2,r2},{c1+2,r2}} )
    draw_line( b, {{c1+1,r1+10},{c1+1,r1+1},{c1+10,r1+1}} )
    draw_line( WHITE, {{c1+2,r1+11}, {c1+11,r1+11}, {c1+11,r1+1}} )

    if check then
        -- the "c"
        c1 = c1 + 3
        r1 = r1 + 3
        pixel( { b,b,w,w,w,b,b }, {c1, r1+0} )
        pixel( { b,b,b,w,b,b,b }, {c1, r1+1} )
        pixel( { w,b,b,b,b,b,w }, {c1, r1+2} )
        pixel( { w,w,b,b,b,w,w }, {c1, r1+3} )
        pixel( { w,b,b,b,b,b,w }, {c1, r1+4} )
        pixel( { b,b,b,w,b,b,b }, {c1, r1+5} )
        pixel( { b,b,w,w,w,b,b }, {c1, r1+6} )
    end if

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_button( sequence title, integer col1, integer row1, 
                integer wide, integer pressed, integer dim, integer hot,
                integer is_focus, integer focus )

    -- draw a button

    integer c1, r1, c2, r2, center, color

    -- hide mouse
    mouse_pointer(0)

    -- dimmed?
    set_black( dim )

    -- convert to points
    c1 = (col1-2)*cWide
    c2 = (col1+wide-2)*cWide
    r1 = ((row1-1)*cTall)-3
    r2 = ((row1)*cTall)+1

    -- button face
    polygon( WHITE, 1, {{c1, r1}, {c2, r1}, {c2, r2}, {c1, r2} } )

    -- title
    center = floor( (wide/2) - (length(title)/2)-1 )
    graphic_title( title, {b, WHITE}, row1, col1+center, hot, is_focus )

    -- focus?
    if focus then
            -- band around button
            polygon( BLACK, 0, {{c1, r1}, {c2,r1}, {c2, r2}, {c1, r2}} )

            -- shrink button
            c1 = c1 + 1
            r1 = r1 + 1
            c2 = c2 - 1
            r2 = r2 - 1

    end if

    -- top reflection
    if pressed then
        color = GRAY
    else
        color = BRIGHT_WHITE
    end if

    draw_line( color, { {c1, r2-1}, {c1, r1}, {c2, r1} } )

    -- optional shadow
    if pressed then
        draw_line( GRAY, {{c1+1, r2-1}, {c1+1, r1+1}, {c2-2, r1+1}} )
    end if

    -- bottom light shadow
    draw_line( GRAY, {{c1+1, r2-1}, {c2-1, r2-1}, {c2-1, r1}} )

    -- bottom dark shadow
    draw_line( BLACK, {{c1, r2}, {c2, r2}, {c2, r1}} )
    
    -- show mouse
    mouse_pointer(1)
    
end procedure


-----------------------------------------------------------------------------
global procedure graphic_thumb( integer row, integer col, integer show )

    -- a "thumb" is 17x17 pixels

    integer c, r

    -- hide mouse
    mouse_pointer(0)

    -- convert to points
    c = col*cWide
    r = row*cTall

    if show = 0 then
        -- erase it
        polygon( WHITE, 1, {{c+1,r},
                            {c+cTall-1,r},
                            {c+cTall-1,r+(cWide*2)},
                            {c+1,r+(cWide*2)}} )

        -- show mouse
        mouse_pointer(1)

        return        
    end if

    -- BLACK surrounding
    polygon( BLACK, 0, {{c,r},
                        {c,r+(cWide*2)},
                        {c+cTall,r+(cWide*2)},
                        {c+cTall,r}} )
    
    -- top reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+cTall-1,r+1}})
    
    -- left reflection
    draw_line( BRIGHT_WHITE, {{c+1,r+1},{c+1,r+(cWide*2)-2}})    
    
    -- bottom shadow
    draw_line( GRAY, {{c+2,r+(cWide*2)-2},{c+cTall-2,r+(cWide*2)-2}})    
    draw_line( GRAY, {{c+1,r+(cWide*2)-1},{c+cTall-2,r+(cWide*2)-1}})    
    
    -- right shadow
    draw_line( GRAY, {{c+cTall-2,r+2},{c+cTall-2,r+(cWide*2)-1}})
    draw_line( GRAY, {{c+cTall-1,r+1},{c+cTall-1,r+(cWide*2)-1}})
    
    -- face
    polygon( WHITE, 1, {{c+2,r+2},
                        {c+cTall-3,r+2},
                        {c+cTall-3,r+(cWide*2)-3},
                        {c+2,r+(cWide*2)-3}} )

    -- show mouse
    mouse_pointer(1)
    
end procedure


----------------------------------------------------------------------------
global procedure graphic_scroll_bar( integer row, integer col, integer deep )

    -- draw the scroll bar

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the scroll bar

        -- convert to points
        c1 = (col-1)*cWide
        r1 = (row)*cTall

        c2 = c1+(2*cWide)
        r2 = r1+(deep*cTall)

        -- border
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

        -- scroll bar
        polygon( WHITE, 1, {{c1+1,r1+1},
                            {c2-1,r1+1},
                            {c2-1,r2-1},
                            {c1+1,r2-1}} )

    -- the up arrow
        -- box
        graphic_thumb( row, col-1, 1 )
    
        -- up arrow
        polygon( BLACK, 1, {{c1+7,r1+6},{c1+4,r1+9},{c1+10,r1+9}} )

    -- the down arrow
        -- box
        graphic_thumb( row+deep-1, col-1, 1 )
    
        -- convert to points
        r1 = (row+deep-1)*cTall
    
        -- down arrow
        polygon( BLACK, 1, {{c1+4,r1+6}, {c1+10,r1+6}, {c1+7,r1+9}} )

    -- show mouse
    mouse_pointer(1)

end procedure


-----------------------------------------------------------------------------
global procedure graphic_frame( integer row, integer col,
                                     integer wide, integer deep )

    -- mle/list frame, with scroll bars

    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- the frame

        -- convert to points
        c1 = (col)*cWide-1
        r1 = (row)*cTall-1

        c2 = c1+((wide-1)*cWide)+1
        r2 = r1+(deep*cTall)+1

        -- draw it
        polygon( BLACK, 0, {{c1,r1},{c2,r1},{c2,r2},{c1,r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure

-----------------------------------------------------------------------------
global procedure graphic_menu( integer col1, integer row1, 
                                    integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- draw a slab

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall) 
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{c1,r1-2},{c2,r1-2},{c2,r2},{c1,r2}})

    -- reflection
    draw_line( BRIGHT_WHITE, {{c1+1, r2-1}, {c1+1, r1-1}, {c2, r1-1}} )

    -- facet shadow
    draw_line( GRAY, {{c2-1, r1-1}, {c2-1, r2-1}, {c1+1, r2-1}} )

    -- shadow
    draw_line( BLACK, {{c2,r1-1}, {c2, r2}, {c1+1, r2}} )

    -- show mouse
    mouse_pointer(1)

end procedure      


-----------------------------------------------------------------------------
global procedure graphic_window( sequence title, integer style, 
            integer color, integer col1, integer row1, 
            integer wide, integer deep )
    
    integer c1, r1, c2, r2

    -- hide mouse
    mouse_pointer(0)

    -- draw a window

    -- adjust to points
    c1 = (col1*cWide)-4
    c2 = ((col1+wide-1)*cWide)+4
    r1 = ((row1-1)*cTall) - 3
    r2 = ((row1+deep-1)*cTall)+2
    
    -- window
    polygon( WHITE, 1, {{c1,r1-4},{c2,r1-4},{c2,r2},{c1,r2}})
    
    -- title bar
    polygon( color, 1, {{c1+4,r1+1},
                        {c2-4,r1+1},
                        {c2-4,r1+18},
                        {c1+4,r1+18}})

    graphic_text( row1, col1+2, BRIGHT_WHITE, color, title )

    -- reflection
    draw_line( BRIGHT_WHITE, {{c1+1, r2-1}, {c1+1, r1-3}, {c2, r1-3}} )

    -- facet shadow
    draw_line( GRAY, {{c2-1, r1-3}, {c2-1, r2-1}, {c1+1, r2-1}} )

    -- shadow
    draw_line( BLACK, {{c2,r1-4}, {c2, r2}, {c1+1, r2}} )

    -- close box
    c1 = ((col1+wide-3)*cWide)
    r1 = ((row1-1)*cTall)

        pixel( { w,w,w,w,w,w,w,w,w,w,w,w,w,b }, {c1, r1+0} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g,b }, {c1, r1+1} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g,b }, {c1, r1+2} )        
        pixel( { w,z,b,b,z,z,z,z,z,b,b,z,g,b }, {c1, r1+3} )
        pixel( { w,z,z,b,b,z,z,z,b,b,z,z,g,b }, {c1, r1+4} )
        pixel( { w,z,z,z,b,b,z,b,b,z,z,z,g,b }, {c1, r1+5} )
        pixel( { w,z,z,z,z,b,b,b,z,z,z,z,g,b }, {c1, r1+6} )
        pixel( { w,z,z,z,z,b,b,b,z,z,z,z,g,b }, {c1, r1+7} )
        pixel( { w,z,z,z,b,b,z,b,b,z,z,z,g,b }, {c1, r1+8} )
        pixel( { w,z,z,b,b,z,z,z,b,b,z,z,g,b }, {c1, r1+9} )
        pixel( { w,z,b,b,z,z,z,z,z,b,b,z,g,b }, {c1, r1+10} )
        pixel( { w,z,z,z,z,z,z,z,z,z,z,z,g,b }, {c1, r1+11} )
        pixel( { w,g,g,g,g,g,g,g,g,g,g,g,g,b }, {c1, r1+12} )
        pixel( { b,b,b,b,b,b,b,b,b,b,b,b,b,b }, {c1, r1+13} )
                   
    -- show mouse
    mouse_pointer(1)

end procedure      



